package main

import (
	"context"
	"errors"
	"fmt"
)

var feeds []Feed
var categories []Category
var entries []Entry
var users []User

func main() {
	var err error
	ctx := context.Background()
	dsn := "postgres://apache:@localhost:5432/miniflux?sslmode=disable"
	// dsn := "unix://user:pass@dbname/var/run/postgresql/.s.PGSQL.5432"

	anvildb := ConnectAnvilDB(dsn)
	// Turn these into funcs with error handling, logging, return vals etc.
	feederr := anvildb.NewSelect().
		Model(&Feed{}).
		OrderExpr("title ASC").
		Limit(10).
		Scan(ctx, &feeds)

	if feederr != nil {
		errors.Join(feederr, err)
	}
	categoryerr := anvildb.NewSelect().
		Model(&Category{}).
		OrderExpr("title ASC").
		Scan(ctx, &categories)
	if categoryerr != nil {
		errors.Join(categoryerr, err)
	}
	entryerr := anvildb.NewSelect().
		Model(&Entry{}).
		OrderExpr("published_at ASC").
		Limit(10).
		Scan(ctx, &entries)
	if entryerr != nil {
		errors.Join(entryerr, err)
	}
	usererr := anvildb.NewSelect().
		Model(&User{}).
		OrderExpr("id ASC").
		Scan(ctx, &users)
	if usererr != nil {
		errors.Join(usererr, err)
	}

	for _, val := range entries {
		fmt.Printf("val = %s\n", val)
	}
	for _, val := range categories {

		fmt.Printf("val = %s\n", val)
	}
	for _, val := range feeds {
		fmt.Printf("val = %s\n", val)
	}
	for _, val := range users {
		fmt.Printf("val = %s\n", val)
	}

	// fmt.Printf("%+v\n", entries)
	// fmt.Printf("%+v\n", categories)
	// fmt.Printf("%+v\n", feeds)
	// fmt.Printf("%+v\n", users)
}
